package com.ruoyi.system.kernel;

import com.ruoyi.system.domain.SnServerTemplate;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.Objects;
import java.util.List;
import com.ruoyi.system.domain.SnServer;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.system.mapper.SnServerTemplateMapper;
import org.springframework.beans.factory.annotation.Autowired;
import com.ruoyi.system.mapper.SnServerMapper;
import org.springframework.stereotype.Service;

@Service
public class DomainValidKernel
{
    @Autowired
    private SnServerMapper snServerMapper;
    @Autowired
    private SnServerTemplateMapper snServerTemplateMapper;
    
    public AjaxResult checkDomain(final String domain, final String ip, final Long exServerId) {
        final SnServer param = new SnServer();
        param.getParams().put("domain", domain);
        param.setIsDelete(Integer.valueOf(0));
        List<SnServer> servers = this.snServerMapper.selectSnServerList(param);
        servers = servers.stream().filter(tmp -> !Objects.equals(tmp.getServerId(), exServerId)).collect((Collector<? super Object, ?, List<SnServer>>)Collectors.toList());
        if (!servers.isEmpty()) {
            return AjaxResult.error(domain + "已被其他服务器使用");
        }
        final SnServerTemplate param2 = new SnServerTemplate();
        param2.getParams().put("domain", domain);
        param2.setIsDelete(Integer.valueOf(0));
        final List<SnServerTemplate> templates = this.snServerTemplateMapper.selectSnServerTemplateList(param2);
        if (!templates.isEmpty()) {
            return AjaxResult.error(domain + "已被其他客户端使用");
        }
        return AjaxResult.success();
    }
}
